"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.promise");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = fetch;

function _bluebird() {
  const data = require("bluebird");

  _bluebird = function () {
    return data;
  };

  return data;
}

function _bitId() {
  const data = require("../../../bit-id");

  _bitId = function () {
    return data;
  };

  return data;
}

function _constants() {
  const data = require("../../../constants");

  _constants = function () {
    return data;
  };

  return data;
}

function _hooks() {
  const data = _interopRequireDefault(require("../../../hooks"));

  _hooks = function () {
    return data;
  };

  return data;
}

function _laneId() {
  const data = require("../../../lane-id/lane-id");

  _laneId = function () {
    return data;
  };

  return data;
}

function _scope() {
  const data = require("../../../scope");

  _scope = function () {
    return data;
  };

  return data;
}

function _scopeComponentsImporter() {
  const data = _interopRequireDefault(require("../../../scope/component-ops/scope-components-importer"));

  _scopeComponentsImporter = function () {
    return data;
  };

  return data;
}

function _compsAndLanesObjects() {
  const data = _interopRequireDefault(require("../../../scope/comps-and-lanes-objects"));

  _compsAndLanesObjects = function () {
    return data;
  };

  return data;
}

function _laneObjects() {
  const data = _interopRequireDefault(require("../../../scope/lane-objects"));

  _laneObjects = function () {
    return data;
  };

  return data;
}

// import logger from '../../../logger/logger';
const HooksManagerInstance = _hooks().default.getInstance();

function fetch(_x, _x2) {
  return _fetch.apply(this, arguments);
}

function _fetch() {
  _fetch = (0, _bluebird().coroutine)(function* (path, ids, // can be Bit ids or Lane ids
  noDependencies = false, idsAreLanes = false, headers) {
    const bitIds = idsAreLanes ? new (_bitId().BitIds)() : _bitId().BitIds.deserialize(ids);
    const laneIds = idsAreLanes ? ids.map(id => _laneId().RemoteLaneId.parse(id)) : []; // @todo: should add "laneIds" to args?

    const args = {
      path,
      bitIds,
      noDependencies
    }; // This might be undefined in case of fork process like during bit test command

    if (HooksManagerInstance) {
      // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!
      HooksManagerInstance.triggerHook(_constants().PRE_SEND_OBJECTS, args, headers);
    }

    const scope = yield (0, _scope().loadScope)(path);
    let componentObjects = [];
    let lanesObjects = [];

    if (idsAreLanes) {
      const lanes = yield scope.listLanes();
      const lanesToFetch = laneIds.map(laneId => {
        const laneToFetch = lanes.find(lane => lane.name === laneId.name); // @todo: throw LaneNotFound, make sure it shows correctly on the client using ssh

        if (!laneToFetch) throw new Error(`lane ${laneId.name} was not found in scope ${scope.name}`);
        return laneToFetch;
      });
      lanesObjects = yield Promise.all(lanesToFetch.map( /*#__PURE__*/function () {
        var _ref = (0, _bluebird().coroutine)(function* (laneToFetch) {
          laneToFetch.scope = scope.name;
          const laneBuffer = yield laneToFetch.compress();
          return new (_laneObjects().default)(laneBuffer, []);
        });

        return function (_x3) {
          return _ref.apply(this, arguments);
        };
      }()));
    } else {
      const scopeComponentsImporter = _scopeComponentsImporter().default.getInstance(scope);

      const importedComponents = noDependencies ? yield scopeComponentsImporter.importManyWithoutDependencies(bitIds, false) : yield scopeComponentsImporter.importMany(bitIds); // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

      const clientVersion = headers ? headers.version : null;
      const collectParents = !noDependencies;
      componentObjects = yield scopeComponentsImporter.componentsToComponentsObjects(importedComponents, clientVersion, collectParents);
    }

    const compsAndLanesObjects = new (_compsAndLanesObjects().default)(componentObjects, lanesObjects);

    if (HooksManagerInstance) {
      yield HooksManagerInstance.triggerHook(_constants().POST_SEND_OBJECTS, {
        componentObjects,
        scopePath: path,
        componentsIds: bitIds.serialize(),
        scopeName: scope.scopeJson.name
      }, // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!
      headers);
    }

    return compsAndLanesObjects;
  });
  return _fetch.apply(this, arguments);
}