import { BitId } from '../bit-id';
import { RemoteLaneId } from '../lane-id/lane-id';
import CompsAndLanesObjects from '../scope/comps-and-lanes-objects';
import DependencyGraph from '../scope/graph/scope-graph';
import Scope from '../scope/scope';
import Remote from './remote';
export default class Remotes extends Map<string, Remote> {
    constructor(remotes?: [string, Remote][]);
    validate(): void;
    resolve(scopeName: string, thisScope?: Scope | null | undefined): Promise<Remote>;
    isHub(scope: any): boolean;
    fetch(ids: BitId[] | RemoteLaneId[], thisScope: Scope, withoutDeps?: boolean, context?: Record<string, any>, idsAreLanes?: boolean): Promise<CompsAndLanesObjects>;
    latestVersions(ids: BitId[], thisScope: Scope): Promise<BitId[]>;
    scopeGraphs(ids: BitId[], thisScope: Scope): Promise<DependencyGraph[]>;
    _groupByScopeName(ids: BitId[]): {
        [scopeName: string]: BitId[];
    };
    toPlainObject(): {};
    static getScopeRemote(scopeName: string): Promise<Remote>;
    static getGlobalRemotes(): Promise<Remotes>;
    static load(remotes: {
        [key: string]: string;
    }): Remotes;
}
